// for publish ~/dart/dart-sdk/bin/pub publish --dry-run
library yomp_cqrs;

import "dart:async";
import "package:yomp_db/yomp_db.dart" as ydb;

part "projection_basic.dart";

class EventSourcing {
	ydb.Storage _store;
	EventSourcing(this._store);

	Future open(String name) {
		Map stores = {"stream":[]};
		return _store.open(name,1,stores);
	}

	Future addEvents(List<Object> events) {
		return _store.add("stream",events);
	}

	Stream<Object> stream() {
		return _store.iterate("stream",[],[],true);
	}

	Future<Map> project(ProjectionBasic proj) {
		Completer comp = new Completer();
		stream().listen((Object event) {
			proj.onEvent(event);
		})..onDone(() {
			comp.complete(proj.result);
		});

		return comp.future;
	}
}