@TestOn("vm")

import "package:yomp_db/storages/memory.dart" as ydb_mems;
import "package:yomp_cqrs/yomp_cqrs.dart" as ycq;
import "package:test/test.dart";
import "tester_data_bands.dart";

void main() {
	group("Basic Stream -",() {
		ydb_mems.StorageMemory store;
		ycq.EventSourcing es;
		setUp(() async {
			store = new ydb_mems.StorageMemory();
			es = new ycq.EventSourcing(store);
			await es.open("test");
		});
		tearDown(() async {
			await store.delete();
		});
		test("first event", () async {
			await es.addEvents([{"event":"Test.create","id":"TEST"}]);
			List<Object> stream = await es.stream().toList();
			expect(stream.length,1);
			expect(stream[0]["event"],"Test.create");

		});
		test("first load test", () async {
			List data = tester_data_bands();
			await es.addEvents(data);
			List<Object> stream = await es.stream().toList();
			expect(stream.length,data.length);
		});

		test("single addition to stream", () async {
			List data = tester_data_bands();
			await es.addEvents(data);
			List<Object> stream = await es.stream().toList();
			expect(stream.length,data.length);
			await es.addEvents([{"event":"Person.set_name","id":"BRUCED", "value":"Bruce 'Sirene' Dickinson"}]);
			stream = await es.stream().toList();
			expect(stream.length,data.length+1);
			expect(stream[data.length]["value"],"Bruce 'Sirene' Dickinson");
		});

	});
}